=begin
#WeFitter API

#This is the WeFitter API

OpenAPI spec version: v1.3
Contact: hello@wefitter.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.38
=end

require 'date'

module WeFitter
  class ProfileCreated
    attr_accessor :url

    attr_accessor :public_id

    attr_accessor :given_name

    attr_accessor :family_name

    attr_accessor :nickname

    attr_accessor :gender

    attr_accessor :birthdate

    attr_accessor :zoneinfo

    attr_accessor :locale

    attr_accessor :reference

    attr_accessor :avatar

    # Used for authenticating as a profile. Make this the active Authorization bearer to perform actions using this profile.
    attr_accessor :bearer

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'url' => :'url',
        :'public_id' => :'public_id',
        :'given_name' => :'given_name',
        :'family_name' => :'family_name',
        :'nickname' => :'nickname',
        :'gender' => :'gender',
        :'birthdate' => :'birthdate',
        :'zoneinfo' => :'zoneinfo',
        :'locale' => :'locale',
        :'reference' => :'reference',
        :'avatar' => :'avatar',
        :'bearer' => :'bearer'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'url' => :'String',
        :'public_id' => :'String',
        :'given_name' => :'String',
        :'family_name' => :'String',
        :'nickname' => :'String',
        :'gender' => :'String',
        :'birthdate' => :'Date',
        :'zoneinfo' => :'String',
        :'locale' => :'String',
        :'reference' => :'String',
        :'avatar' => :'String',
        :'bearer' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'url')
        self.url = attributes[:'url']
      end

      if attributes.has_key?(:'public_id')
        self.public_id = attributes[:'public_id']
      end

      if attributes.has_key?(:'given_name')
        self.given_name = attributes[:'given_name']
      end

      if attributes.has_key?(:'family_name')
        self.family_name = attributes[:'family_name']
      end

      if attributes.has_key?(:'nickname')
        self.nickname = attributes[:'nickname']
      end

      if attributes.has_key?(:'gender')
        self.gender = attributes[:'gender']
      end

      if attributes.has_key?(:'birthdate')
        self.birthdate = attributes[:'birthdate']
      end

      if attributes.has_key?(:'zoneinfo')
        self.zoneinfo = attributes[:'zoneinfo']
      end

      if attributes.has_key?(:'locale')
        self.locale = attributes[:'locale']
      end

      if attributes.has_key?(:'reference')
        self.reference = attributes[:'reference']
      end

      if attributes.has_key?(:'avatar')
        self.avatar = attributes[:'avatar']
      end

      if attributes.has_key?(:'bearer')
        self.bearer = attributes[:'bearer']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@given_name.nil? && @given_name.to_s.length > 100
        invalid_properties.push('invalid value for "given_name", the character length must be smaller than or equal to 100.')
      end

      if !@family_name.nil? && @family_name.to_s.length > 100
        invalid_properties.push('invalid value for "family_name", the character length must be smaller than or equal to 100.')
      end

      if !@nickname.nil? && @nickname.to_s.length > 100
        invalid_properties.push('invalid value for "nickname", the character length must be smaller than or equal to 100.')
      end

      if !@locale.nil? && @locale.to_s.length > 5
        invalid_properties.push('invalid value for "locale", the character length must be smaller than or equal to 5.')
      end

      if @reference.nil?
        invalid_properties.push('invalid value for "reference", reference cannot be nil.')
      end

      if @reference.to_s.length > 256
        invalid_properties.push('invalid value for "reference", the character length must be smaller than or equal to 256.')
      end

      if @reference.to_s.length < 1
        invalid_properties.push('invalid value for "reference", the character length must be great than or equal to 1.')
      end

      if !@avatar.nil? && @avatar.to_s.length < 1
        invalid_properties.push('invalid value for "avatar", the character length must be great than or equal to 1.')
      end

      if !@bearer.nil? && @bearer.to_s.length < 1
        invalid_properties.push('invalid value for "bearer", the character length must be great than or equal to 1.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@given_name.nil? && @given_name.to_s.length > 100
      return false if !@family_name.nil? && @family_name.to_s.length > 100
      return false if !@nickname.nil? && @nickname.to_s.length > 100
      gender_validator = EnumAttributeValidator.new('String', ['M', 'F', 'X'])
      return false unless gender_validator.valid?(@gender)
      return false if !@locale.nil? && @locale.to_s.length > 5
      return false if @reference.nil?
      return false if @reference.to_s.length > 256
      return false if @reference.to_s.length < 1
      return false if !@avatar.nil? && @avatar.to_s.length < 1
      return false if !@bearer.nil? && @bearer.to_s.length < 1
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] given_name Value to be assigned
    def given_name=(given_name)
      if !given_name.nil? && given_name.to_s.length > 100
        fail ArgumentError, 'invalid value for "given_name", the character length must be smaller than or equal to 100.'
      end

      @given_name = given_name
    end

    # Custom attribute writer method with validation
    # @param [Object] family_name Value to be assigned
    def family_name=(family_name)
      if !family_name.nil? && family_name.to_s.length > 100
        fail ArgumentError, 'invalid value for "family_name", the character length must be smaller than or equal to 100.'
      end

      @family_name = family_name
    end

    # Custom attribute writer method with validation
    # @param [Object] nickname Value to be assigned
    def nickname=(nickname)
      if !nickname.nil? && nickname.to_s.length > 100
        fail ArgumentError, 'invalid value for "nickname", the character length must be smaller than or equal to 100.'
      end

      @nickname = nickname
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] gender Object to be assigned
    def gender=(gender)
      validator = EnumAttributeValidator.new('String', ['M', 'F', 'X'])
      unless validator.valid?(gender)
        fail ArgumentError, 'invalid value for "gender", must be one of #{validator.allowable_values}.'
      end
      @gender = gender
    end

    # Custom attribute writer method with validation
    # @param [Object] locale Value to be assigned
    def locale=(locale)
      if !locale.nil? && locale.to_s.length > 5
        fail ArgumentError, 'invalid value for "locale", the character length must be smaller than or equal to 5.'
      end

      @locale = locale
    end

    # Custom attribute writer method with validation
    # @param [Object] reference Value to be assigned
    def reference=(reference)
      if reference.nil?
        fail ArgumentError, 'reference cannot be nil'
      end

      if reference.to_s.length > 256
        fail ArgumentError, 'invalid value for "reference", the character length must be smaller than or equal to 256.'
      end

      if reference.to_s.length < 1
        fail ArgumentError, 'invalid value for "reference", the character length must be great than or equal to 1.'
      end

      @reference = reference
    end

    # Custom attribute writer method with validation
    # @param [Object] avatar Value to be assigned
    def avatar=(avatar)
      if !avatar.nil? && avatar.to_s.length < 1
        fail ArgumentError, 'invalid value for "avatar", the character length must be great than or equal to 1.'
      end

      @avatar = avatar
    end

    # Custom attribute writer method with validation
    # @param [Object] bearer Value to be assigned
    def bearer=(bearer)
      if !bearer.nil? && bearer.to_s.length < 1
        fail ArgumentError, 'invalid value for "bearer", the character length must be great than or equal to 1.'
      end

      @bearer = bearer
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          url == o.url &&
          public_id == o.public_id &&
          given_name == o.given_name &&
          family_name == o.family_name &&
          nickname == o.nickname &&
          gender == o.gender &&
          birthdate == o.birthdate &&
          zoneinfo == o.zoneinfo &&
          locale == o.locale &&
          reference == o.reference &&
          avatar == o.avatar &&
          bearer == o.bearer
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [url, public_id, given_name, family_name, nickname, gender, birthdate, zoneinfo, locale, reference, avatar, bearer].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = WeFitter.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
